"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var plugin_1 = require("stryker-api/plugin");
exports.MUTATORS_TOKEN = 'mutators';
mutatorsFactory.inject = plugin_1.tokens(plugin_1.commonTokens.pluginResolver, plugin_1.commonTokens.injector);
function mutatorsFactory(pluginResolver, injector) {
    var mutators = {};
    var mutatorPlugins = pluginResolver.resolveAll(plugin_1.PluginKind.Mutator);
    mutatorPlugins.forEach(function (plugin) {
        if (plugin.name !== 'es5' && plugin.name !== 'vue') {
            mutators[plugin.name] = createPlugin(injector, plugin);
        }
    });
    return mutators;
}
exports.mutatorsFactory = mutatorsFactory;
function createPlugin(injector, plugin) {
    if (isFactoryPlugin(plugin)) {
        return injector.injectFunction(plugin.factory);
    }
    else {
        return injector.injectClass(plugin.injectableClass);
    }
}
function isFactoryPlugin(plugin) {
    return !!plugin.factory;
}
//# sourceMappingURL=MutatorHelpers.js.map